#ifndef _space_h_
#define _space_h_

#include "allegro.h"
#include <vector>

using namespace std;

class HullObject;
class WeaponObject;
class ExplosionClass;
class Section;
class Group;
class SpaceObject{
public:

	SpaceObject( int sx, int sy, double qx, double qy, HullObject * mhull, Group * _group, int plane, int ali );

	//Hitme: calls hull->Inside( x, y, ax, ay )
	virtual bool HitMe( int ax, int ay );

	//Collide: determines if have collided with another object
	virtual bool Collide(SpaceObject * check);

	//Damage: decreases life returns true if 0 or less
	virtual bool Damage( int much );

	//Hurt: returns amount of damage object does when colliding with 
	//another object
	virtual int Hurt();

	//Draw: if plane == g then draw self
	virtual void Draw(BITMAP * less, ExplosionClass ** _expl, int MAX_EXPLR, int g, int offset );

	//Shadow: draw a shadow the same way as the Draw() method
	virtual void Shadow(BITMAP * less, int g, int offset );
	
	//MoveReal: generic algorithm to move coordinates with doubles
	virtual void MoveReal();

	//PowerUp: determines whether or not ship should turn into a powerup or money
	virtual bool powerUp();

	//GiveHull: replace old hull with hnew
	virtual void giveHull( HullObject * hnew );

	virtual bool needSpecial();
	virtual bool acceptSpecial();

	virtual Group * group();
	
	//ammo - array of pointers to bullets
	//fight = array of pointers to ships
	virtual bool MoveMe( vector< SpaceObject * > * Ammo, vector< SpaceObject * > * fight, Section * onscreen,DATAFILE * snd);

	//process: changes check according to death of object
	virtual void Died(SpaceObject * check,ExplosionClass ** explr,int ME,DATAFILE * sd );

	//process: returns hull->life
	virtual int getLife();

	//returns alignment
	virtual int Team();

	//return dx and dy respectively
	virtual double DX();
	virtual double DY();

	//process: sets the coordinates to x=ax, y=ay
	void SetCoordXY( int ax, int ay );

	//process: increments objects score
	virtual void IncScore( int j );

	//returns hull->drawlevel
	virtual int lookPlane();

	//process: returns whether or not object can be hit
	virtual bool CanbeHit( SpaceObject * ht );
	
	//gives the hull a weapon at slot num
	virtual void giveWeapon( WeaponObject * weap, int num );

	virtual void eraseWeapon( int num );

	virtual void Collided( SpaceObject * who, ExplosionClass ** explr, int M_EX );

	//adds an object to the collide list
	virtual void addCollide( SpaceObject * who );

	//check to see if the object is in the collide list
	virtual bool haveCollide( SpaceObject * who );

	//clears the collide list
	virtual void clearCollide();

	//destructor
	virtual ~SpaceObject();

	//returns an exact copy of this object
	virtual SpaceObject * copy();

	int actualx, actualy;
	double virtualx, virtualy;
	double dx, dy;
	int score;
	int str;

	int plane;
	int alignment;

	HullObject * hull;
	vector< SpaceObject * > * collide_list;
	Group * my_group;

};

#endif
